]> git.notmuchmail.org Git - notmuch/blob - test/test-lib.sh
test: Fix the search and dump-restore tests to operator on non-empty mail store.
[notmuch] / test / test-lib.sh
1 #!/bin/bash
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see http://www.gnu.org/licenses/ .
17
18 # if --tee was passed, write the output not only to the terminal, but
19 # additionally to the file test-results/$BASENAME.out, too.
20 case "$GIT_TEST_TEE_STARTED, $* " in
21 done,*)
22         # do not redirect again
23         ;;
24 *' --tee '*|*' --va'*)
25         mkdir -p test-results
26         BASE=test-results/$(basename "$0" .sh)
27         (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
28          echo $? > $BASE.exit) | tee $BASE.out
29         test "$(cat $BASE.exit)" = 0
30         exit
31         ;;
32 esac
33
34 # Keep the original TERM for say_color
35 ORIGINAL_TERM=$TERM
36
37 # For repeatability, reset the environment to known value.
38 LANG=C
39 LC_ALL=C
40 PAGER=cat
41 TZ=UTC
42 TERM=dumb
43 export LANG LC_ALL PAGER TERM TZ
44 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
45
46 # Protect ourselves from common misconfiguration to export
47 # CDPATH into the environment
48 unset CDPATH
49
50 unset GREP_OPTIONS
51
52 # Convenience
53 #
54 # A regexp to match 5 and 40 hexdigits
55 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
56 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
57
58 _x04='[0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
59 _x32="$_x04$_x04$_x04$_x04$_x04$_x04$_x04$_x04"
60
61 # Each test should start with something like this, after copyright notices:
62 #
63 # test_description='Description of this test...
64 # This test checks if command xyzzy does the right thing...
65 # '
66 # . ./test-lib.sh
67 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
68                 TERM=$ORIGINAL_TERM &&
69                 export TERM &&
70                 [ -t 1 ] &&
71                 tput bold >/dev/null 2>&1 &&
72                 tput setaf 1 >/dev/null 2>&1 &&
73                 tput sgr0 >/dev/null 2>&1
74         ) &&
75         color=t
76
77 while test "$#" -ne 0
78 do
79         case "$1" in
80         -d|--d|--de|--deb|--debu|--debug)
81                 debug=t; shift ;;
82         -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
83                 immediate=t; shift ;;
84         -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
85                 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
86         -h|--h|--he|--hel|--help)
87                 help=t; shift ;;
88         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
89                 verbose=t; shift ;;
90         -q|--q|--qu|--qui|--quie|--quiet)
91                 quiet=t; shift ;;
92         --with-dashes)
93                 with_dashes=t; shift ;;
94         --no-color)
95                 color=; shift ;;
96         --no-python)
97                 # noop now...
98                 shift ;;
99         --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
100                 valgrind=t; verbose=t; shift ;;
101         --tee)
102                 shift ;; # was handled already
103         --root=*)
104                 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
105                 shift ;;
106         *)
107                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
108         esac
109 done
110
111 if test -n "$color"; then
112         say_color () {
113                 (
114                 TERM=$ORIGINAL_TERM
115                 export TERM
116                 case "$1" in
117                         error) tput bold; tput setaf 1;; # bold red
118                         skip)  tput bold; tput setaf 2;; # bold green
119                         pass)  tput setaf 2;;            # green
120                         info)  tput setaf 3;;            # brown
121                         *) test -n "$quiet" && return;;
122                 esac
123                 shift
124                 printf " "
125                 printf "$@"
126                 tput sgr0
127                 )
128         }
129 else
130         say_color() {
131                 test -z "$1" && test -n "$quiet" && return
132                 shift
133                 printf " "
134                 printf "$@"
135         }
136 fi
137
138 error () {
139         say_color error "error: $*"
140         GIT_EXIT_OK=t
141         exit 1
142 }
143
144 say () {
145         say_color info "$*"
146 }
147
148 test "${test_description}" != "" ||
149 error "Test script did not set test_description."
150
151 if test "$help" = "t"
152 then
153         echo "Tests ${test_description}"
154         exit 0
155 fi
156
157 echo $(basename "$0"): "Testing ${test_description}"
158
159 exec 5>&1
160 if test "$verbose" = "t"
161 then
162         exec 4>&2 3>&1
163 else
164         exec 4>/dev/null 3>/dev/null
165 fi
166
167 test_failure=0
168 test_count=0
169 test_fixed=0
170 test_broken=0
171 test_success=0
172
173 die () {
174         code=$?
175         if test -n "$GIT_EXIT_OK"
176         then
177                 exit $code
178         else
179                 echo >&5 "FATAL: Unexpected exit with code $code"
180                 exit 1
181         fi
182 }
183
184 GIT_EXIT_OK=
185 trap 'die' EXIT
186
187 test_decode_color () {
188         sed     -e 's/.\[1m/<WHITE>/g' \
189                 -e 's/.\[31m/<RED>/g' \
190                 -e 's/.\[32m/<GREEN>/g' \
191                 -e 's/.\[33m/<YELLOW>/g' \
192                 -e 's/.\[34m/<BLUE>/g' \
193                 -e 's/.\[35m/<MAGENTA>/g' \
194                 -e 's/.\[36m/<CYAN>/g' \
195                 -e 's/.\[m/<RESET>/g'
196 }
197
198 q_to_nul () {
199         perl -pe 'y/Q/\000/'
200 }
201
202 q_to_cr () {
203         tr Q '\015'
204 }
205
206 append_cr () {
207         sed -e 's/$/Q/' | tr Q '\015'
208 }
209
210 remove_cr () {
211         tr '\015' Q | sed -e 's/Q$//'
212 }
213
214 # Notmuch helper functions
215 increment_mtime_amount=0
216 increment_mtime ()
217 {
218     dir="$1"
219
220     increment_mtime_amount=$((increment_mtime_amount + 1))
221     touch -d "+${increment_mtime_amount} seconds" "$dir"
222 }
223
224 # Generate a new message in the mail directory, with a unique message
225 # ID and subject. The message is not added to the index.
226 #
227 # After this function returns, the filename of the generated message
228 # is available as $gen_msg_filename and the message ID is available as
229 # $gen_msg_id .
230 #
231 # This function supports named parameters with the bash syntax for
232 # assigning a value to an associative array ([name]=value). The
233 # supported parameters are:
234 #
235 #  [dir]=directory/of/choice
236 #
237 #       Generate the message in directory 'directory/of/choice' within
238 #       the mail store. The directory will be created if necessary.
239 #
240 #  [body]=text
241 #
242 #       Text to use as the body of the email message
243 #
244 #  '[from]="Some User <user@example.com>"'
245 #  '[to]="Some User <user@example.com>"'
246 #  '[subject]="Subject of email message"'
247 #  '[date]="RFC 822 Date"'
248 #
249 #       Values for email headers. If not provided, default values will
250 #       be generated instead.
251 #
252 #  '[cc]="Some User <user@example.com>"'
253 #  [reply-to]=some-address
254 #  [in-reply-to]=<message-id>
255 #  [references]=<message-id>
256 #  [content-type]=content-type-specification
257 #  '[header]=full header line, including keyword'
258 #
259 #       Additional values for email headers. If these are not provided
260 #       then the relevant headers will simply not appear in the
261 #       message.
262 #
263 #  '[id]=message-id'
264 #
265 #       Controls the message-id of the created message.
266 gen_msg_cnt=0
267 gen_msg_filename=""
268 gen_msg_id=""
269 generate_message ()
270 {
271     # This is our (bash-specific) magic for doing named parameters
272     local -A template="($@)"
273     local additional_headers
274
275     gen_msg_cnt=$((gen_msg_cnt + 1))
276     gen_msg_name=msg-$(printf "%03d" $gen_msg_cnt)
277
278     if [ -z "${template[id]}" ]; then
279         gen_msg_id="${gen_msg_name}@notmuch-test-suite"
280     else
281         gen_msg_id="${template[id]}"
282     fi
283
284     if [ -z "${template[dir]}" ]; then
285         gen_msg_filename="${MAIL_DIR}/$gen_msg_name"
286     else
287         gen_msg_filename="${MAIL_DIR}/${template[dir]}/$gen_msg_name"
288         mkdir -p "$(dirname "$gen_msg_filename")"
289     fi
290
291     if [ -z "${template[body]}" ]; then
292         template[body]="This is just a test message (#${gen_msg_cnt})"
293     fi
294
295     if [ -z "${template[from]}" ]; then
296         template[from]="Notmuch Test Suite <test_suite@notmuchmail.org>"
297     fi
298
299     if [ -z "${template[to]}" ]; then
300         template[to]="Notmuch Test Suite <test_suite@notmuchmail.org>"
301     fi
302
303     if [ -z "${template[subject]}" ]; then
304         template[subject]="Test message #${gen_msg_cnt}"
305     fi
306
307     if [ -z "${template[date]}" ]; then
308         template[date]="Tue, 05 Jan 2001 15:43:57 -0000"
309     fi
310
311     additional_headers=""
312     if [ ! -z "${template[header]}" ]; then
313         additional_headers="${template[header]}
314 ${additional_headers}"
315     fi
316
317     if [ ! -z "${template[reply-to]}" ]; then
318         additional_headers="Reply-To: ${template[reply-to]}
319 ${additional_headers}"
320     fi
321
322     if [ ! -z "${template[in-reply-to]}" ]; then
323         additional_headers="In-Reply-To: ${template[in-reply-to]}
324 ${additional_headers}"
325     fi
326
327     if [ ! -z "${template[cc]}" ]; then
328         additional_headers="Cc: ${template[cc]}
329 ${additional_headers}"
330     fi
331
332     if [ ! -z "${template[references]}" ]; then
333         additional_headers="References: ${template[references]}
334 ${additional_headers}"
335     fi
336
337     if [ ! -z "${template[content-type]}" ]; then
338         additional_headers="Content-Type: ${template[content-type]}
339 ${additional_headers}"
340     fi
341
342
343 cat <<EOF >"$gen_msg_filename"
344 From: ${template[from]}
345 To: ${template[to]}
346 Message-Id: <${gen_msg_id}>
347 Subject: ${template[subject]}
348 Date: ${template[date]}
349 ${additional_headers}
350 ${template[body]}
351 EOF
352
353     # Ensure that the mtime of the containing directory is updated
354     increment_mtime "$(dirname "${gen_msg_filename}")"
355 }
356
357 # Generate a new message and add it to the database.
358 #
359 # All of the arguments and return values supported by generate_message
360 # are also supported here, so see that function for details.
361 add_message ()
362 {
363     generate_message "$@" &&
364     notmuch new > /dev/null
365 }
366
367 # Generate a corpus of email and add it to the database.
368 #
369 # This corpus is fixed, (it happens to be 50 messages from early in
370 # the history of the notmuch mailing list), which allows for reliably
371 # testing commands that need to operate on a not-totally-trivial
372 # number of messages.
373 add_email_corpus ()
374 {
375     rm -rf ${MAIL_DIR}
376     if [ -d ../corpus.mail ]; then
377         cp -a ../corpus.mail ${MAIL_DIR}
378     else
379         cp -a ../corpus ${MAIL_DIR}
380         notmuch new
381         cp -a ${MAIL_DIR} ../corpus.mail
382     fi
383 }
384
385 test_begin_subtest ()
386 {
387     test_subtest_name="$1"
388 }
389
390 # Pass test if two arguments match
391 #
392 # Note: Unlike all other test_expect_* functions, this function does
393 # not accept a test name. Instead, the caller should call
394 # test_begin_subtest before calling this function in order to set the
395 # name.
396 test_expect_equal ()
397 {
398         test "$#" = 3 && { prereq=$1; shift; } || prereq=
399         test "$#" = 2 ||
400         error "bug in the test script: not 2 or 3 parameters to test_expect_equal"
401
402         output="$1"
403         expected="$2"
404         if ! test_skip "$@"
405         then
406                 if [ "$output" = "$expected" ]; then
407                         test_ok_ "$test_subtest_name"
408                 else
409                         testname=$this_test.$test_count
410                         echo "$expected" > $testname.expected
411                         echo "$output" > $testname.output
412                         test_failure_ "$test_subtest_name" "$(diff -u $testname.expected $testname.output)"
413                 fi
414     fi
415 }
416
417 NOTMUCH_NEW ()
418 {
419     notmuch new | grep -v -E -e '^Processed [0-9]*( total)? file|Found [0-9]* total file'
420 }
421
422 notmuch_search_sanitize ()
423 {
424     sed -r -e 's/("?thread"?: ?)("?)................("?)/\1\2XXX\3/'
425 }
426
427 NOTMUCH_SHOW_FILENAME_SQUELCH='s,filename:.*/mail,filename:/XXX/mail,'
428 notmuch_show_sanitize ()
429 {
430     sed -e "$NOTMUCH_SHOW_FILENAME_SQUELCH"
431 }
432
433 # End of notmuch helper functions
434
435 # Use test_set_prereq to tell that a particular prerequisite is available.
436 # The prerequisite can later be checked for in two ways:
437 #
438 # - Explicitly using test_have_prereq.
439 #
440 # - Implicitly by specifying the prerequisite tag in the calls to
441 #   test_expect_{success,failure,code}.
442 #
443 # The single parameter is the prerequisite tag (a simple word, in all
444 # capital letters by convention).
445
446 test_set_prereq () {
447         satisfied="$satisfied$1 "
448 }
449 satisfied=" "
450
451 test_have_prereq () {
452         case $satisfied in
453         *" $1 "*)
454                 : yes, have it ;;
455         *)
456                 ! : nope ;;
457         esac
458 }
459
460 # You are not expected to call test_ok_ and test_failure_ directly, use
461 # the text_expect_* functions instead.
462
463 test_ok_ () {
464         test_success=$(($test_success + 1))
465         say_color pass "%-6s" "PASS"
466         echo " $@"
467 }
468
469 test_failure_ () {
470         test_failure=$(($test_failure + 1))
471         say_color error "%-6s" "FAIL"
472         echo " $1"
473         shift
474         echo "$@" | sed -e 's/^/        /'
475         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
476 }
477
478 test_known_broken_ok_ () {
479         test_fixed=$(($test_fixed+1))
480         say_color pass "%-6s" "FIXED"
481         echo " $@"
482 }
483
484 test_known_broken_failure_ () {
485         test_broken=$(($test_broken+1))
486         say_color pass "%-6s" "BROKEN"
487         echo " $@"
488 }
489
490 test_debug () {
491         test "$debug" = "" || eval "$1"
492 }
493
494 test_run_ () {
495         test_cleanup=:
496         eval >&3 2>&4 "$1"
497         eval_ret=$?
498         eval >&3 2>&4 "$test_cleanup"
499         return 0
500 }
501
502 test_skip () {
503         test_count=$(($test_count+1))
504         to_skip=
505         for skp in $NOTMUCH_SKIP_TESTS
506         do
507                 case $this_test.$test_count in
508                 $skp)
509                         to_skip=t
510                 esac
511         done
512         if test -z "$to_skip" && test -n "$prereq" &&
513            ! test_have_prereq "$prereq"
514         then
515                 to_skip=t
516         fi
517         case "$to_skip" in
518         t)
519                 say_color skip >&3 "skipping test: $@"
520                 say_color skip "%-6s" "SKIP"
521                 echo " $1"
522                 : true
523                 ;;
524         *)
525                 false
526                 ;;
527         esac
528 }
529
530 test_expect_failure () {
531         test "$#" = 3 && { prereq=$1; shift; } || prereq=
532         test "$#" = 2 ||
533         error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
534         if ! test_skip "$@"
535         then
536                 test_run_ "$2"
537                 if [ "$?" = 0 -a "$eval_ret" = 0 ]
538                 then
539                         test_known_broken_ok_ "$1"
540                 else
541                         test_known_broken_failure_ "$1"
542                 fi
543         fi
544 }
545
546 test_expect_success () {
547         test "$#" = 3 && { prereq=$1; shift; } || prereq=
548         test "$#" = 2 ||
549         error "bug in the test script: not 2 or 3 parameters to test-expect-success"
550         if ! test_skip "$@"
551         then
552                 test_run_ "$2"
553                 if [ "$?" = 0 -a "$eval_ret" = 0 ]
554                 then
555                         test_ok_ "$1"
556                 else
557                         test_failure_ "$@"
558                 fi
559         fi
560 }
561
562 test_expect_code () {
563         test "$#" = 4 && { prereq=$1; shift; } || prereq=
564         test "$#" = 3 ||
565         error "bug in the test script: not 3 or 4 parameters to test-expect-code"
566         if ! test_skip "$@"
567         then
568                 test_run_ "$3"
569                 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
570                 then
571                         test_ok_ "$2"
572                 else
573                         test_failure_ "$@"
574                 fi
575         fi
576 }
577
578 # test_external runs external test scripts that provide continuous
579 # test output about their progress, and succeeds/fails on
580 # zero/non-zero exit code.  It outputs the test output on stdout even
581 # in non-verbose mode, and announces the external script with "* run
582 # <n>: ..." before running it.  When providing relative paths, keep in
583 # mind that all scripts run in "trash directory".
584 # Usage: test_external description command arguments...
585 # Example: test_external 'Perl API' perl ../path/to/test.pl
586 test_external () {
587         test "$#" = 4 && { prereq=$1; shift; } || prereq=
588         test "$#" = 3 ||
589         error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
590         descr="$1"
591         shift
592         if ! test_skip "$descr" "$@"
593         then
594                 # Announce the script to reduce confusion about the
595                 # test output that follows.
596                 say_color "" " run $test_count: $descr ($*)"
597                 # Run command; redirect its stderr to &4 as in
598                 # test_run_, but keep its stdout on our stdout even in
599                 # non-verbose mode.
600                 "$@" 2>&4
601                 if [ "$?" = 0 ]
602                 then
603                         test_ok_ "$descr"
604                 else
605                         test_failure_ "$descr" "$@"
606                 fi
607         fi
608 }
609
610 # Like test_external, but in addition tests that the command generated
611 # no output on stderr.
612 test_external_without_stderr () {
613         # The temporary file has no (and must have no) security
614         # implications.
615         tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
616         stderr="$tmp/git-external-stderr.$$.tmp"
617         test_external "$@" 4> "$stderr"
618         [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
619         descr="no stderr: $1"
620         shift
621         if [ ! -s "$stderr" ]; then
622                 rm "$stderr"
623                 test_ok_ "$descr"
624         else
625                 if [ "$verbose" = t ]; then
626                         output=`echo; echo Stderr is:; cat "$stderr"`
627                 else
628                         output=
629                 fi
630                 # rm first in case test_failure exits.
631                 rm "$stderr"
632                 test_failure_ "$descr" "$@" "$output"
633         fi
634 }
635
636 # This is not among top-level (test_expect_success | test_expect_failure)
637 # but is a prefix that can be used in the test script, like:
638 #
639 #       test_expect_success 'complain and die' '
640 #           do something &&
641 #           do something else &&
642 #           test_must_fail git checkout ../outerspace
643 #       '
644 #
645 # Writing this as "! git checkout ../outerspace" is wrong, because
646 # the failure could be due to a segv.  We want a controlled failure.
647
648 test_must_fail () {
649         "$@"
650         test $? -gt 0 -a $? -le 129 -o $? -gt 192
651 }
652
653 # test_cmp is a helper function to compare actual and expected output.
654 # You can use it like:
655 #
656 #       test_expect_success 'foo works' '
657 #               echo expected >expected &&
658 #               foo >actual &&
659 #               test_cmp expected actual
660 #       '
661 #
662 # This could be written as either "cmp" or "diff -u", but:
663 # - cmp's output is not nearly as easy to read as diff -u
664 # - not all diff versions understand "-u"
665
666 test_cmp() {
667         $GIT_TEST_CMP "$@"
668 }
669
670 # This function can be used to schedule some commands to be run
671 # unconditionally at the end of the test to restore sanity:
672 #
673 #       test_expect_success 'test core.capslock' '
674 #               git config core.capslock true &&
675 #               test_when_finished "git config --unset core.capslock" &&
676 #               hello world
677 #       '
678 #
679 # That would be roughly equivalent to
680 #
681 #       test_expect_success 'test core.capslock' '
682 #               git config core.capslock true &&
683 #               hello world
684 #               git config --unset core.capslock
685 #       '
686 #
687 # except that the greeting and config --unset must both succeed for
688 # the test to pass.
689
690 test_when_finished () {
691         test_cleanup="{ $*
692                 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
693 }
694
695 test_done () {
696         GIT_EXIT_OK=t
697         test_results_dir="$TEST_DIRECTORY/test-results"
698         mkdir -p "$test_results_dir"
699         test_results_path="$test_results_dir/${0%.sh}-$$"
700
701         echo "total $test_count" >> $test_results_path
702         echo "success $test_success" >> $test_results_path
703         echo "fixed $test_fixed" >> $test_results_path
704         echo "broken $test_broken" >> $test_results_path
705         echo "failed $test_failure" >> $test_results_path
706         echo "" >> $test_results_path
707
708         echo
709
710         if [ "$test_failure" = "0" ]; then
711             rm -rf "$remove_tmp"
712             exit 0
713         else
714             exit 1
715         fi
716 }
717
718 find_notmuch_path ()
719 {
720     dir="$1"
721
722     while [ -n "$dir" ]; do
723         bin="$dir/notmuch"
724         if [ -x "$bin" ]; then
725             echo "$dir"
726             return
727         fi
728         dir="$(dirname "$dir")"
729         if [ "$dir" = "/" ]; then
730             break
731         fi
732     done
733 }
734
735 # Test the binaries we have just built.  The tests are kept in
736 # test/ subdirectory and are run in 'trash directory' subdirectory.
737 TEST_DIRECTORY=$(pwd)
738 if test -n "$valgrind"
739 then
740         make_symlink () {
741                 test -h "$2" &&
742                 test "$1" = "$(readlink "$2")" || {
743                         # be super paranoid
744                         if mkdir "$2".lock
745                         then
746                                 rm -f "$2" &&
747                                 ln -s "$1" "$2" &&
748                                 rm -r "$2".lock
749                         else
750                                 while test -d "$2".lock
751                                 do
752                                         say "Waiting for lock on $2."
753                                         sleep 1
754                                 done
755                         fi
756                 }
757         }
758
759         make_valgrind_symlink () {
760                 # handle only executables
761                 test -x "$1" || return
762
763                 base=$(basename "$1")
764                 symlink_target=$TEST_DIRECTORY/../$base
765                 # do not override scripts
766                 if test -x "$symlink_target" &&
767                     test ! -d "$symlink_target" &&
768                     test "#!" != "$(head -c 2 < "$symlink_target")"
769                 then
770                         symlink_target=../valgrind.sh
771                 fi
772                 case "$base" in
773                 *.sh|*.perl)
774                         symlink_target=../unprocessed-script
775                 esac
776                 # create the link, or replace it if it is out of date
777                 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
778         }
779
780         # override notmuch executable in TEST_DIRECTORY/..
781         GIT_VALGRIND=$TEST_DIRECTORY/valgrind
782         mkdir -p "$GIT_VALGRIND"/bin
783         make_valgrind_symlink $TEST_DIRECTORY/../notmuch
784         OLDIFS=$IFS
785         IFS=:
786         for path in $PATH
787         do
788                 ls "$path"/notmuch 2> /dev/null |
789                 while read file
790                 do
791                         make_valgrind_symlink "$file"
792                 done
793         done
794         IFS=$OLDIFS
795         PATH=$GIT_VALGRIND/bin:$PATH
796         GIT_EXEC_PATH=$GIT_VALGRIND/bin
797         export GIT_VALGRIND
798 else # normal case
799         notmuch_path=`find_notmuch_path "$TEST_DIRECTORY"`
800         test -n "$notmuch_path" && PATH="$notmuch_path:$PATH"
801 fi
802 export PATH
803
804 # Test repository
805 test="tmp.$(basename "$0" .sh)"
806 test -n "$root" && test="$root/$test"
807 case "$test" in
808 /*) TMP_DIRECTORY="$test" ;;
809  *) TMP_DIRECTORY="$TEST_DIRECTORY/$test" ;;
810 esac
811 test ! -z "$debug" || remove_tmp=$TMP_DIRECTORY
812 rm -fr "$test" || {
813         GIT_EXIT_OK=t
814         echo >&5 "FATAL: Cannot prepare test area"
815         exit 1
816 }
817
818 MAIL_DIR="${TMP_DIRECTORY}/mail"
819 export NOTMUCH_CONFIG="${TMP_DIRECTORY}/notmuch-config"
820
821 mkdir -p "${test}"
822 mkdir -p "${MAIL_DIR}"
823
824 cat <<EOF >"${NOTMUCH_CONFIG}"
825 [database]
826 path=${MAIL_DIR}
827
828 [user]
829 name=Notmuch Test Suite
830 primary_email=test_suite@notmuchmail.org
831 other_email=test_suite_other@notmuchmail.org;test_suite@otherdomain.org
832 EOF
833
834
835 # Use -P to resolve symlinks in our working directory so that the cwd
836 # in subprocesses like git equals our $PWD (for pathname comparisons).
837 cd -P "$test" || error "Cannot setup test environment"
838
839 this_test=${0##*/}
840 this_test=${this_test%%-*}
841 for skp in $NOTMUCH_SKIP_TESTS
842 do
843         to_skip=
844         for skp in $NOTMUCH_SKIP_TESTS
845         do
846                 case "$this_test" in
847                 $skp)
848                         to_skip=t
849                 esac
850         done
851         case "$to_skip" in
852         t)
853                 say_color skip >&3 "skipping test $this_test altogether"
854                 say_color skip "skip all tests in $this_test"
855                 test_done
856         esac
857 done
858
859 # Provide an implementation of the 'yes' utility
860 yes () {
861         if test $# = 0
862         then
863                 y=y
864         else
865                 y="$*"
866         fi
867
868         while echo "$y"
869         do
870                 :
871         done
872 }
873
874 # Fix some commands on Windows
875 case $(uname -s) in
876 *MINGW*)
877         # Windows has its own (incompatible) sort and find
878         sort () {
879                 /usr/bin/sort "$@"
880         }
881         find () {
882                 /usr/bin/find "$@"
883         }
884         sum () {
885                 md5sum "$@"
886         }
887         # git sees Windows-style pwd
888         pwd () {
889                 builtin pwd -W
890         }
891         # no POSIX permissions
892         # backslashes in pathspec are converted to '/'
893         # exec does not inherit the PID
894         ;;
895 *)
896         test_set_prereq POSIXPERM
897         test_set_prereq BSLASHPSPEC
898         test_set_prereq EXECKEEPSPID
899         ;;
900 esac
901
902 test -z "$NO_PERL" && test_set_prereq PERL
903 test -z "$NO_PYTHON" && test_set_prereq PYTHON
904
905 # test whether the filesystem supports symbolic links
906 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
907 rm -f y